\documentclass[a4paper]{article}
\usepackage[left=2.2cm,right=2.2cm,top=2.5cm,bottom=2.5cm]{geometry} % page settings
\usepackage{amsmath}
\usepackage{amssymb}
%\usepackage{amsthm}
%\usepackage{etoolbox}
\usepackage[english]{babel}
\usepackage[utf8]{inputenc}
%\usepackage{framed}
\usepackage{fancyhdr}
%\usepackage{tikz}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\setlength{\parskip}{\medskipamount}
\setlength{\parindent}{0pt}

\pagestyle{fancy}
\lhead{
    \begin{tabular}{ll}
      Lab Course Deep Learning \\
      Winter term 2017/18
  \end{tabular}
}
\chead{}
\rhead{
  \begin{tabular}{ll}
    Fabian Glöckle \\
    26/11/2017
  \end{tabular}
}
\lfoot{}
\cfoot{}
\rfoot{} 


\begin{document}

\title{Deep Learning Lab Course Report 2}
\author{Fabian Glöckle}
\date{\today}
% \maketitle

\subsection*{An autoencoder for MNIST}

In this exercice, we implemented a simple autoencoder for the MNIST digits dataset. The code can be found on my gitlab repo \footnote{\url{https://gitlab.com/fabian.g/deep-learning/tree/master}}.

\subsubsection*{Architecture}
\begin{itemize}
  \item Convolutional layer with 8 filters and ReLU activation.
  \item Max pooling layer.
  \item Convolutional layer with 4 filters and ReLU activation.
  \item Max pooling layer.
  \item Convolutional layer with 2 filters and ReLU activation.
  \item Tansposed convolutional layer with 4 filters and ReLU activation.
  \item Convolutional layer with 4 filters and ReLU activation.
  \item Tansposed convolutional layer with 8 filters and ReLU activation.
  \item Convolutional layer with 8 filters and ReLU activation.
  \item Convolutional output layer for affine linear rescaling with ReLU activation (one $1 \times 1$ filter.
\end{itemize}

The convolutional layers use $3 \times 3$ filters with stride one. The max pooling and transposed convolution layers work on $2 \times 2$ squares with stride two, so without overlap.

The network is trained to minimize the $L^2$-loss of the difference of input and output image. For training, the Adam optimizer was used on the first 7000 training images of the dataset, in minibatches of 64 images.

\subsubsection*{Results}

\begin{figure}[h!] 
\includegraphics[width=\textwidth]{plots.png} 
\caption{Training curves for different learning rates. $L^2$-loss by epoch. Learning rates: blue: 0.1, orange: 0.01, green: 0.001.}
\label{fig1}
\end{figure}

Figure 1 shows the $L^2$-loss with respect to whole dataset epochs. Training here seems \textbf{most effective with a learning rate of around 0.001}. The higher value of 0.01 shows slight instability and surprisingly converges more slowly, the even higher one of 0.1 does not change the network result at all, which can be explained with the following observation:

\texttt{Learning rate= 0.1, epoch 0, loss 0.11441756784915924 \\  
Learning rate= 0.1, epoch 1, loss 0.11441756784915924 \\  
Norms of layer weights: [73.720627, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
}

The last line shows the $L^2$-norm of all weight tensors in the network. As most of them \textbf{have become zero}, we can assume that in the first training epoch the gradients indicated that most weights were mainly increasing the loss. As the learning rate was too high, these weights were subsequently changed to a value that left the network in the constant zero part of the ReLU-function from which it cannot recover with gradient descent.

\subsubsection*{Auto-Encoded images by the network}

\begin{figure}[h!] 
\includegraphics[width=\textwidth]{sample_images.png} 
\caption{Sample images from the autoencoder network. First row: input images. Second row: output of the auto-encoder network. Third row: distorted images. Fourth row: output of distorted images.}
\label{fig2}
\end{figure}

Figure 2 shows input and output images from the autoencoder network. In the third row, the images were distorted with a normal distribution of mean zero and standard deviation of 0.1. The output images show a \textbf{remarkable similarity} to the input, despite their reduction from 784 dimensions down to 196. However, even simple compression algorithms could probably exploit the simple structure of the digits equally well. The network's internal representation of course does not correspond to digits, as can be seen in the last two images, both depicting an eight. This is because \textbf{unsupervised}, the network is not trained to identify substantially different versions of the same letter with each other.

The question on the exercise sheet implies that \textbf{noise} added to the image might dramatically decrease the network's performance as its representation may be overfitted. In the above example however, I do not see such an effect.

\end{document}
